% $Id: BRelTest.oz,v 1.1 2011/10/06 02:14:35 leavens Exp $
\insert 'BRel.oz'
\insert 'TestingNoStop.oz'
{System.showInfo ""}
{Show 'Since these tests use Assert, you will only see'}
{Show 'messages about what is being tested and failure messages if tests fail.'}
{StartTesting 'BRelTest $Revision: 1.1 $'}
{StartTesting 'Provided code'}
{Assert {BRelEqual {AsBRel nil} {EmptyBRel}}}
{Assert {BRelEqual {AsBRel [3#c 1#a 2#b 3#c]} {AsBRel [1#a 2#b 3#c]}}}
{Assert {BRelHas {AsBRel [3#c 1#a 2#b 3#c]} 2 b}}
{Assert {Not {BRelHas {AsBRel [3#c 1#a 2#b 3#c]} 2 c}}}
{Assert {Not {BRelHasKey {AsBRel [3#c 1#a 2#b 3#c]} a}}}
{Assert {BRelHasKey {AsBRel [3#c 1#a 2#b 3#c]} 3}}
{Assert {IsBRel {AsBRel [3#c 1#a 2#b 3#c]}}}
{Assert {BRelSubset {EmptyBRel} {AsBRel [3#c 1#a 2#b 3#c]}}}
{Assert {Not {BRelSubset {AsBRel [1#c]} {AsBRel [3#c 1#a 2#b 3#c]}}}}
{StartTesting 'BRelAdd'}
{Assert {BRelEqual {BRelAdd {EmptyBRel} 1 1} {AsBRel [1#1]}}}
{Assert {BRelEqual {BRelAdd {EmptyBRel} c 3} {AsBRel [c#3]}}}
{Assert {BRelEqual {BRelAdd {AsBRel [a#b b#c c#d]} d e}
                   {AsBRel [a#b b#c c#d d#e]}}}
{Assert {BRelEqual {BRelAdd {EmptyBRel} c 3} {AsBRel [c#3]}}}
{Assert {BRelEqual {BRelAdd {BRelAdd {EmptyBRel} 2 funky} 3 town}
                   {AsBRel [2#funky 3#town]}}}
{Assert {BRelEqual {BRelAdd {AsBRel [2#3 1#2]} 9 10} 
                   {BRelAdd {BRelAdd {BRelAdd {EmptyBRel} 9  10} 2 3} 1 2}}}

{StartTesting 'BRelApply'}
{Assert {BRelApply {AsBRel [a#b b#c c#d d#e]} c} == [d]}
{Assert {BRelApply {AsBRel [a#b a#c a#d a#g]} a} == [b c d g]}
{Assert {BRelApply {AsBRel [a#c a#d a#g]} a} == [c d g]}
{Assert {BRelApply {AsBRel [3#c 1#a 2#b 3#d]} a} == nil}
{Assert {BRelApply {AsBRel [3#c 1#a 2#b 3#d]} 3} == [c d]}
{Assert {BRelApply {AsBRel [1#a 2#b 3#d]} 3} == [d]}
{Assert {BRelApply {AsBRel [3#c 1#a 2#b 3#d]} 4} == nil}
{Assert {BRelApply {AsBRel [3#c 1#a 2#b 3#d]} 1} == [a]}
{StartTesting 'BRelUnion'}
{Assert {BRelEqual {BRelUnion {EmptyBRel} {EmptyBRel}} {EmptyBRel}}}
{Assert {BRelEqual {BRelUnion {EmptyBRel} {AsBRel [3#c 1#a 2#b 3#d]}}
                    {AsBRel [3#c 1#a 2#b 3#d]}}}
{Assert {BRelEqual {BRelUnion {AsBRel [3#c 1#a 2#b 3#d]}
                              {AsBRel [1#a 3#c 2#b 3#d]}}
                              {AsBRel [3#c 1#a 2#b 3#d]}}}
{Assert {BRelEqual {BRelUnion {AsBRel [3#c 1#a 2#b 3#d]}
                              {AsBRel [7#f 8#g 9#i 10#k]}}
                   {AsBRel [3#c 1#a 2#b 3#d 7#f 8#g 9#i 10#k]}}}
{StartTesting 'BRelDiff'}
{Assert {BRelEqual {BRelDiff {AsBRel [3#c 1#a 2#b 3#d]} {EmptyBRel}} 
                   {AsBRel [3#c 1#a 2#b 3#d]}}}
{Assert {BRelEqual {BRelDiff {AsBRel [3#c 1#a 2#b 3#d]}
                             {AsBRel [3#c 1#a 2#b 3#d]}}
                   {EmptyBRel}}}
{Assert {BRelEqual {BRelDiff {AsBRel [3#c 1#a 2#b 3#d]} {AsBRel [3#d 2#b]}}
                   {AsBRel [3#c 1#a]}}}
{Assert {BRelEqual {BRelDiff {AsBRel [3#c 1#a 2#b 3#d]} {AsBRel [3#e 2#c]}}
                   {AsBRel [3#c 1#a 2#b 3#d]}}}
{Assert {BRelEqual {BRelDiff {AsBRel [1#2 2#3 5#6 3#4 7#8]}
                              {AsBRel [7#8 2#3]}}
                    {AsBRel [1#2 5#6 3#4]}}}
{Assert {BRelEqual {BRelDiff {AsBRel [3#c 1#a 2#b 3#d]}
                              {AsBRel [7#f 8#g 9#i 10#k]}}
                   {AsBRel [3#c 1#a 2#b 3#d]}}}

{StartTesting 'BRelCompose'}
{Assert {BRelEqual {BRelCompose {EmptyBRel} {AsBRel [2#b 3#c]}} {EmptyBRel}}}
{Assert {BRelEqual {BRelCompose {EmptyBRel} {EmptyBRel}} {EmptyBRel}}}
{Assert {BRelEqual {BRelCompose {AsBRel [1#2 2#3]} {AsBRel [2#b 3#c]}}
                   {AsBRel [1#b 2#c]}}}
{Assert {BRelEqual {BRelCompose {AsBRel [1#3 2#3]} {AsBRel [3#b 3#c]}}
                   {AsBRel [1#b 1#c 2#b 2#c]}}}

{StartTesting 'ProductBRel'}
{Assert {BRelEqual {ProductBRel nil [b c]} {EmptyBRel}}}
{Assert {BRelEqual {ProductBRel [b c] nil} {EmptyBRel}}}
{Assert {BRelEqual {ProductBRel [b c] [1 2 3]}
                   {AsBRel [b#1 b#2 b#3 c#1 c#2 c#3]}}}
{Assert {BRelEqual {ProductBRel [1 2 3] [b c]}
                   {AsBRel [1#b 2#b 3#b 1#c 2#c 3#c]}}}
{Assert {BRelEqual {ProductBRel [1] [a]}
                   {AsBRel [1#a]}}}
{DoneTesting}
