// $Id: OzListTest.cpp,v 1.2 2011/09/25 13:56:06 leavens Exp leavens $
// AUTHOR: Gary T. Leavens
#include <iostream>
#include <string>
#include <assert.h>
#include "OzList.h"
using namespace std;

template <typename T> long length(OzList<T> const * ls) {
  long count = 0L;
  while (!ls->isEmpty()) {
    count++;
    ls = ls->tail();
  }
  return count;
}

int main(int argc, char **argv) {
  cout << "OzListTest $Revision: 1.2 $" << "\n" << flush;
  cout << "test of empty list" << "\n" << flush;
  OzList<int> const * myLs = new OzEmptyList<int>();
  assert (myLs->isEmpty());
  assert (length(myLs) == 0);
  cout << "test of 1 element list" << "\n" << flush;
  OzList<int> const * ls = new OzEmptyList<int>();
  ls = new OzCons<int>(3, ls);
  assert (length(ls) == 1);
  assert (ls->head() == 3);
  assert (ls->tail()->isEmpty());
  cout << "test of 2 element list" << "\n" << flush;
  OzList<int> const * ls2 = new OzCons<int>(99, ls);
  assert (length(ls2) == 2);
  assert (length(ls) == 1);
  assert (ls2->head() == 99);
  assert (ls2->tail()->head() == 3);
  assert (length(ls2) == 2);
  cout << "test of 3 element list" << "\n" << flush;
  OzList<int> const * ls3 = new OzCons<int>(86, ls2);
  assert (length(ls3) == 3);
  assert (ls3->head() == 86);
  assert (ls3->tail()->head() == 99);
  assert (length(ls2) == 2);
  assert (length(ls) == 1);
  cout << "test of string lists" << "\n" << flush;
  OzList<string> const * lss = new OzEmptyList<string>();
  lss = new OzCons<string>("first", lss);
  assert (length(lss) == 1);
  assert (lss->head() == "first");
  assert (lss->tail()->isEmpty());
  OzList<string> const * newLs = lss;
  newLs = new OzCons<string>("second", lss);
  assert (length(lss) == 1);
  assert (lss->head() == "first");
  assert (lss->tail()->isEmpty());
  assert (length(newLs) == 2);
  assert (newLs->head() == "second");
  assert (newLs->tail()->head() == "first");
  cout << "done" << "\n" << flush;
  return 0;
}
